class ExamsController < ApplicationController

  def allows_to?(action)
    return(current_user.has_role?("examiner"))
  end

  def new
    @categories = Category.all.delete_if{|category| category.questions.empty?}
  end

  def create
    mix_questions = (defined?(params[:mix_questions]) and (params[:mix_questions] == "1"))
    mix_choices = (defined?(params[:mix_choices]) and (params[:mix_choices] == "1"))
    @categories = {}
    params[:categories].each do |info|
      category_id = info[0].to_i
      count = info[1].to_i
      category = Category.find(category_id)
      max_count = category.questions.length
      count = 0 if count < 0
      count = max_count if count > max_count
      questions = Question.find_all_by_category_id(category_id, :include => [:choices])
      while (questions.length > count) do
        questions.delete_at(rand(questions.length))
      end
      questions.shuffle! if mix_questions
      if mix_choices
        questions.each do |question|
          question.choices.shuffle!
        end
      end
      @categories[category_id] = {:category => category, :count => count, :questions => questions} if count > 0
    end
    render(:layout => "print")
  end
  
end
